<template>
<div>
 <roles-heading :title="username" :logged="false"/>
  <v-main>
    <v-row justify="center">
      <v-col md="6" cols="12">
        <div class="box">
        <!-- TITULO Y BIENVENIDA -->
        <v-row justify="center">Inficadores de éxito</v-row>
        <v-row justify="center"><strong>Sistema de Tutoría</strong></v-row>
        <!-- FORMULARIO PARA PASSWORD -->
        <v-row justify="center">
          <v-form ref="form" v-model="valid">
            <v-row v-for="(field,index) in fields" :key="index">
              <v-col>
                <v-label>{{ field.label }}</v-label>
                <v-radio-group v-model="field.value" :mandatory="false" required>
                  <v-radio v-for="(option,index) in field.options" :label="option.label" :value="option.value" :key="index"></v-radio>
                </v-radio-group>
              </v-col>
            </v-row>
            <v-row>
              <v-col>
                <v-label>{{ sixth.label }}</v-label>
                <v-checkbox
                  v-for="(option,index) in sixth.options" :label="option.label" v-model="option.value" :key="index"
                ></v-checkbox>
              </v-col>
            </v-row>
            <v-row justify="center">
            <st-primary-btn :disabled="!valid" :loading="loading" @click="post" nombre="Enviar calificación"/>
            </v-row>
          </v-form>
        </v-row>
        <!-- AVISO DE RESULTADO -->
          <v-dialog v-model="dialog" max-width="390">
            <v-card>
              <v-card-title>{{ card.title }}</v-card-title>
              <v-card-text>{{ card.text }}</v-card-text>
              <v-card-actions class="pb-5">
                <div class="goLogin">
                  <st-primary-btn link="/" nombre="Ir al Login"/>
                </div>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </div>
      </v-col>
    </v-row>
  </v-main>
</div>
</template>

<script>
import RolesHeading from '@/components/TheRolesHeading.vue'
import tokenTool from "@/assets/js/token-tool";

  export default {
    layout:'simple',
    name: "Califacion",
    components:{
      'roles-heading': RolesHeading,
    },
    data() { return {
      username: '',
      expDate: null,
      exp: null,
      valid: true,
      loading: false,
      dialog:false,
      card:{
        title: 'Gracias por calificarnos',
        text: 'Se ha registrado la calificación de tu sesion',
      },
      fields:{
        first:{
          value: 0,
          label: '1. Satisfacción con el acompañamiento del programa de tutoría del 1 al 5 (insatisfecho a totalmente satisfecho)',
          options:[
            { label: '1', value:1},
            { label: '2', value:2},
            { label: '3', value:3},
            { label: '4', value:4},
            { label: '5', value:5},
          ]
        },
        second:{
          value: 0,
          label: '2. Utilidad del programa de tutoría del 1 al 5 (sin utilidad a totalmente útil)',
          options:[
            { label: '1', value:1},
            { label: '2', value:2},
            { label: '3', value:3},
            { label: '4', value:4},
            { label: '5', value:5},
          ]
        },
        third:{
          value: null,
          label: '3. ¿Utilizó las recomendaciones para toma de decisiones?',
          options:[
            { label: 'Sí', value:true},
            { label: 'No', value:false},
          ]
        },
        fourth:{
          value: null,
          label: '4. ¿El programa solucionó su situación?',
          options:[
            { label: 'Sí', value:true},
            { label: 'No', value:false},
          ]
        },
        fifth:{
          value: null,
          label: '5. ¿Recomendaría el programa de tutoría a sus pares?',
          options:[
            { label: 'Sí', value:true},
            { label: 'No', value:false},
          ]
        },
      },
      sixth:{
          value: [],
          label: '6. Motivos de consulta',
          options:[
            { label: 'Académico', value:false},
            { label: 'Académico – administrativo', value:false},
            { label: 'Vocacional', value:false},
            { label: 'Personal', value:false},
            { label: 'Familiar', value:false},
            { label: 'Individual', value:false},
            { label: 'Económico', value:false},
            { label: 'Psicológico', value:false},
          ],
        },
    }},
    computed: {
      tokenExpired() {
        return false;
      }
    },
    methods:{
      async post(){
        this.$refs.form.validate();
        this.loading = true;
        if (this.valid) {
          try {
            let fields = this.fields
            let reasons1 = this.sixth.options.filter(obj => obj.value === true)
            let reasons2 = reasons1.map(obj => obj.label)
            let indicators = {
              token: this.$route.params.token,
              data:{
                indicador1: fields.first.value,
                indicador2: fields.second.value,
                indicador3: fields.third.value,
                indicador4: fields.fourth.value,
                indicador5: fields.fifth.value,
                indicador6: reasons2.toString()
              }
            }
            let { data: { message } } = await this.$api.calificateSession(indicators);
            this.dialog=true
          }
          catch(e) {
            this.dialog = true
            this.card.title = 'Error'
            if (e.response) this.card.text = e.response.data.message
          }
          this.loading = false;
        }
      }
    },
    created() {
      const tokenPayload = tokenTool.getPayload(this.$route.params.token);
      if (tokenPayload) {
        this.username = tokenPayload.usuario;
        this.exp = tokenPayload.exp;
        this.expDate = new Date(tokenPayload.expFormat);
      } else {
        this.$router.push('/');
      }
    }

  }
</script>

<style scoped>
.box{
  max-width:700px
}
.goLogin{
  margin:0 auto;
}
</style>
